VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} RecentFilesChanging 
   Caption         =   "Laufwerkswechsel"
   ClientHeight    =   3795
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7635
   OleObjectBlob   =   "RecentFilesChanging.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "RecentFilesChanging"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim strNewDrive As String   ' neuer Laufwerksname (new drive name)

' alle Laufwerke und Typ auflisten (list all the drives and their types)
Sub DriveTypeAndList()  
  Dim objDrv As Object
  With lstDrives
    For Each objDrv In CreateObject("Scripting.FileSystemObject").Drives
      Select Case objDrv.DriveType
        Case 0:
          .AddItem (objDrv.DriveLetter & ": (" & objDrv.VolumeName & ")" & " - (Unknown)")
        Case 1:
          .AddItem (objDrv.DriveLetter & ": (" & objDrv.VolumeName & ")" & " - (Removable)")
        Case 2:
          .AddItem (objDrv.DriveLetter & ": (" & objDrv.VolumeName & ")" & " - (Hard-Disk)")
        Case 3:
          .AddItem (objDrv.DriveLetter & ": (" & objDrv.VolumeName & ")" & " - (Network)")
        Case 4: 
          .AddItem (objDrv.DriveLetter & ": (CD-ROM)")
        Case 5:
          .AddItem (objDrv.DriveLetter & ": (" & objDrv.VolumeName & ")" & " - (RAM-Disk)")
      End Select
    Next 
  End With
  Set objDrv = Nothing
End Sub

' alle RecentFiles auflisten (list all the RecentFiles names)
Sub getRecentFiles()
  Dim i As Integer, strn, strp As String
  With Application.RecentFiles
    For i = 1 To .Count
      strn = .Item(i).Name
      strp = .Item(i).Path
      lstRecentFiles.AddItem strp 'hinzufgen des genderten RecentFiles
    Next i
  End With
End Sub

' gegebenenfalls das markierte RecentFile mit neuem Laufwerk listen
' (lists the marked RecentFiles with a new drive name)
Sub ChangeRecentFiles() 
  Dim strPath, strName As String
  Dim strNewPath, strNewName As String
  Dim i As Integer
  For i = 0 To lstRecentFiles.ListCount - 1
    ' ist die Datei in der Listbox markiert
    ' (is the file marked in the listbox)
    If lstRecentFiles.Selected(i) = True Then
      ' wenn ja (if yes):
      With Application.RecentFiles
        strName = .Item(i + 1).Name
        strPath = .Item(i + 1).Path
        strNewPath = strNewDrive & Right(strPath, Len(strPath) - 2)

        ' lschen des alten Listeneintrags (delete the old list item)
        .Item(i + 1).Delete

        ' hinzufgen des neuen Listeneintrags (add the new list item)
        .Add Name:=strNewPath
      End With
    End If
  Next i
End Sub

' Button 'abbrechen' (cancel button)
Private Sub CommandButton1_Click()
  Unload Me
End Sub

' Button 'ausfhren' (do button)
Private Sub CommandButton2_Click()
  Dim idx As Integer
  idx = lstDrives.ListIndex
  ' ist neues Laufwerk markiert (is a new drive marked)
  If idx >= 0 Then
    strNewDrive = Left(lstDrives.Value, 2)
    ' die nderungen ausfhren (do the changes)
    ChangeRecentFiles
    lstRecentFiles.Clear
    ' die neuen Listeintrge anzeigen (show the new list items)
    getRecentFiles
  Else
    ' (no drive choosen!)
    MsgBox ("Kein Laufwerk ausgewhlt!")
  End If
End Sub

Private Sub UserForm_Activate()
  ' Liste der Laufwerke erzeugen (get a list of drives)
  DriveTypeAndList
  ' Liste der RecentFiles erzeugen (get a list of the RecentFiles)
  getRecentFiles
End Sub
